/*
# Date:        2016-07-29
# Author:      simonzhang
# web:         www.simonzhang.net
# Email:       simon-zzm@163.com
*/
package main

import (
   "os"
   "io"
   "fmt"
   "strings"
   "bufio"
   "os/exec"
   "runtime"
)

func checkRAR(passwd string) {
    var tmpPass string = "-p"+passwd
    cmd := exec.Command("rar", "t", "tt.rar", tmpPass)
    status := cmd.Run()
    if (status == nil){ 
        fmt.Println("tt.rar pass is ", passwd)
        os.Exit(1)
    }
}

func start(c chan string){
    // 读密码文件
    passFile := "passwd.txt"
    pf,err := os.Open(passFile)
    if err != nil {
        fmt.Println(passFile,err)
        os.Exit(1)
    }
    defer pf.Close()
    //
    rd := bufio.NewReader(pf)
    for {
        //以'\n'为结束符读入一行
        line, err := rd.ReadString('\n')
        if err != nil || io.EOF == err {
            break
        }
        tmpPass := strings.Replace(line, "\n", "", -1)
        /* 如果是Linux上编辑的密码文件下步不需要。
           如果密码文本是在windows下编辑的可能会带^M
           不可见字符。应用vim -v 或者cat -A 可以看到。
        */
        tmpPass = strings.Replace(tmpPass, "\r", "", -1)
        checkRAR(tmpPass) 
    } 
}

func main() {
    //计算cpu核数
    var loopnum int = runtime.NumCPU()
    //设置协程cpu核数
    runtime.GOMAXPROCS(loopnum)
    c := make(chan string)
    for i:=0; i<=loopnum; i++ {
        go start(c)
    }
    <- c
    fmt.Println("not find password")
}
